'use strict';

var DashboardObraController = angular.module('DashboardObraController', []);

DashboardObraController.controller('DashboardObraCtrl', ['$scope', '$location', 'Construcao', 'Relatorio', 'Material', 'CacheApp',
  ($scope, $location, Construcao, Relatorio, Material, CacheApp) => {

    $scope.getFisicoFinanceiro = (construcao) => {
        $scope.fisicoFinanceiro = {};

        var plota = {
            type: 'line',
            objName: 'line-fisico-financeiro',
            showLegend: true,
            showYAxes: true,
            showXAxes: true,
            labels: [],
            dataSet:[]
        };
        
        var lineCronograma = {
            label: 'Cronograma',
            type: 'line',
            borderColor: 'rgba(38,49,67,0.9)',
            backgroundColor: 'rgba(38,49,67,0.2)',
            showYAxes: true,
            showXAxes: true,
            data: []
        }
        
        var lineFisico = {
            label: 'Físico',
            type: 'line',
            borderColor: 'rgba(250,162,0,0.9)',
            backgroundColor: 'rgba(250,162,0,0.2)',
            data: []
        }

        Relatorio.getCronogramaFisicoFinanceiro(construcao.Id,
            (dataCronog) => {
                $scope.retornoCronograma = true
                $scope.showDashboar.Cronograma = dataCronog.Instance.length > 0

                dataCronog.Instance.forEach((c,i) => {
                    plota.labels.push(i+1);
                    lineCronograma.data.push(c.Acum);
                })

                plota.dataSet.push(lineCronograma);

                var planoFisico = construcao.Acessos ? construcao.Acessos.indexOf('GET_AVANCO') >= 0 : false;

                if (planoFisico)
                    Relatorio.getFisicoFinanceiro(construcao.Id, construcao.DataInicio, construcao.DataInicio,
                        (dataFisico) => {
                            if (dataFisico.Instance) {
                                dataFisico.Instance.forEach((f,i) => {
                                    lineFisico.data.push(f.Fisico);
                                    if (i >= lineCronograma.data.length)
                                        plota.labels.push(i+1);
                                })
    
                                plota.dataSet.push(lineFisico);
                                $scope.plotaChart(plota);
                            }
                        }
                    );
                else {
                    $scope.plotaChart(plota);
                }

            });

    }

    $scope.getOrcamento = (construcao) => {

        if (construcao.ValorBDIEncargos > 0) {
            $scope.showDashboar.Orcamento = true;
            var plota = {
                type: 'bar',
                // options: $scope.getOptionsLine('', true),
                objName: 'bar-tipoinsumo',
                titulo: 'Orçado por tipo de insumo',
                showLegend: false,
                showYAxes: true,
                showXAxes: true,
                labels: [],
                dataSet: []
            };
    
            plota.dataSet = [{
                borderColor: [
                    'rgba(38, 49, 67, 0.9)',
                    'rgba(60, 118, 61, 0.9)',
                    'rgba(138, 109, 59, 0.9)',
                    'rgba(51, 122, 183, 0.9)',
                    'rgba(255, 68, 68, 0.9)'
                ],
                backgroundColor: [
                    'rgba(38, 49, 67, 0.9)',
                    'rgba(60, 118, 61, 0.9)',
                    'rgba(138, 109, 59, 0.9)',
                    'rgba(51, 122, 183, 0.9)',
                    'rgba(255, 68, 68, 0.9)'
                ],
                borderWidth: 0.5,
                data: [
                    construcao.ValorBDIEncargosMDO,
                    construcao.ValorBDIMAT,
                    construcao.ValorBDIEQU,
                    construcao.ValorBDISER,
                    construcao.ValorBDITAX
                ]
            }];

            plota.labels = [
                'Mão-de-obra',
                'Material',
                'Equipamento',
                'Serviço',
                'Taxa'
            ];

            $scope.plotaChart(plota);

            var lineEtapa = {
                label: 'Etapa',
                borderColor: 'rgba(38, 49, 67, 0.9)',
                backgroundColor: 'rgba(38, 49, 67, 0.9)',
                data: [],
                type: 'bar',
            }

            var plota1 = {
                type: 'bar',
                objName: 'bar-orcamento',
                titulo: 'Orçado por etapa',
                showLegend: false,
                showYAxes: true,
                showXAxes: true,
                labels: [],
                dataSet: [lineEtapa]
            };

            Relatorio.getOrcamentoBDIExplicitoSintetico($scope.construcao.Id,
                (data) => {
                    $scope.retornoOrcamento = true
                    $scope.listaEtapa = data.Instance.Etapas;
                    $scope.listaEtapa.forEach(l => {
                        plota1.labels.push(l.Etapa.substring(0,10) + (l.Etapa.length >10 ? '...' : '' ))
                        lineEtapa.data.push(l.ValorBDIEncargos);
                    })

                    while (lineEtapa.data.length < 10) {
                        plota1.labels.push('');
                        lineEtapa.data.push(0)
                    }
    
                    $scope.plotaChart(plota1);
                    $scope.getCustoEtapa();
                    $scope.getMedicaoEtapa();
                });
        }
        else {
            $scope.retornoOrcamento = true
            $scope.retornoMedicao = true
            $scope.showDashboar.Orcamento = false
            $scope.showDashboar.Medicao = false
        }
    }

    $scope.getCreditoDebitoObra = (construcao) => {
        if (construcao.ValorGastoBase > 0) {
            $scope.showDashboar.Financeiro = true
            Construcao.getCreditoDebitoObra(construcao.Id, $scope.opcaoFluxoCaixa ? $scope.opcaoFluxoCaixa : 8,
                (data) => {
                    $scope.retornoFinanceiro = true;
                    var lineDebito = {
                        label: 'Custo',
                        borderColor: 'rgba(220,0,0,0.9)',
                        backgroundColor: 'rgba(220,0,0,0.9)',
                        data: []
                    }
                    
                    var lineCredito = {
                        label: 'Receita',
                        borderColor: 'rgba(38,49,67,0.9)',
                        backgroundColor: 'rgba(38,49,67,0.9)',
                        data: []
                    }

                    var lineSaldo = {
                        label: 'Saldo',
                        borderColor: 'rgba(250,162,0,1)',
                        backgroundColor: 'rgba(250,162,0,0.1)',
                        data: [],
                        type: 'line',
                        fill: false,
                        lineTension: 0
                    }

                    var plota = {
                        type: 'bar',
                        objName: 'bar-financeiro',
                        titulo: 'Fluxo de caixa por mês',
                        showLegend: true,
                        showYAxes: true,
                        showXAxes: true,
                        stackedBar: true,
                        labels: [],
                        dataSet:[lineDebito, lineCredito, lineSaldo]
                    };

                    data.Instance.forEach(l => {
                        plota.labels.push(l.Periodo);
                        lineDebito.data.push(l.Debito);
                        lineCredito.data.push(l.Credito);
                        lineSaldo.data.push(l.Saldo);
                    });

                    while (lineDebito.data.length < 10) {
                        plota.labels.push('');
                        lineDebito.data.push(0)
                    }
                    while (lineCredito.data.length < 10) {
                        lineCredito.data.push(0)
                    }
                        
                    $scope.plotaChart(plota);
                }
            );
        } else {
            $scope.retornoFinanceiro = true
            $scope.showDashboar.Financeiro = false
        }
    }

    $scope.getConstrucao = () => {
        var construcao = CacheApp.getConstrucao();
        var params = { 
            Tipo: 1, 
            IdClienteAdmin: $scope.sessao.ContaAdmin ? $scope.sessao.IdClienteAdmin : undefined,
            IdConstrucao: construcao.Id
        }
        Construcao.getConstrucoes(params,
        (data) => {
            construcao = data.Instance[0];
            CacheApp.setConstrucao(construcao);
            $scope.construcao = construcao

            var datanow = $scope.construcao.DataFinalizada ? new Date($scope.construcao.DataFinalizada) : Date.now();

            $scope.construcao.diasDeObra = Math.ceil((Math.abs(new Date($scope.construcao.DataInicio) - new Date($scope.construcao.DataFim))) / (1000 * 3600 * 24));

            if (datanow < new Date($scope.construcao.DataInicio)) {
                $scope.construcao.dias = Math.ceil((Math.abs(new Date($scope.construcao.DataInicio) - new Date($scope.construcao.DataFim))) / (1000 * 3600 * 24));
            }
                // Bug Cliente
            else if (datanow < new Date($scope.construcao.DataFim)) {
                $scope.construcao.dias = Math.ceil((Math.abs(datanow - new Date($scope.construcao.DataFim))) / (1000 * 3600 * 24));
                $scope.construcao.atrasado = false;
            }
            else {
                $scope.construcao.dias = Math.ceil((Math.abs(new Date($scope.construcao.DataFim) - datanow)) / (1000 * 3600 * 24));
                $scope.construcao.atrasado = true;
            }

            var temCronograma = construcao.Acessos ? construcao.Acessos.indexOf('GET_PLANEJAR') >= 0 : false;
            var temFinanceiro = construcao.Acessos ? construcao.Acessos.indexOf('GET_FINANCEIRO') >= 0 : false;
            var temCompras = construcao.Acessos ? construcao.Acessos.indexOf('GET_COMPRA_SOLICITACAO') >= 0 : false;
            var temRDO = construcao.Acessos ? construcao.Acessos.indexOf('GET_DIARIOOBRA') >= 0 : false;

            $scope.getOrcamento(construcao);

            if (temCronograma)
                $scope.getFisicoFinanceiro(construcao);

            if (temFinanceiro) {
                $scope.getCreditoDebitoObra(construcao);
                $scope.getHistogramaCusto();
                $scope.getCustoCategoria();
                $scope.getCurvaAbcFornecedor();
            }
            if (temCompras)
                $scope.getResumoCompras();
            if (temRDO) {
                $scope.getResumoRDO();
                $scope.getResumoTempo();
            }
        });
    }

    $scope.detalheDashboard = (path) => {
        $location.path('/' + path);
    }

    $scope.getHistogramaCusto = () => {
        var params = {
            IdConstrucao: $scope.construcao.Id,
            Periodo: $scope.opcaoFluxoCaixa ? $scope.opcaoFluxoCaixa : 8
        }
        Relatorio.getHistogramaAcumulado(params,
            (data) => {
                var lineDebito = {
                    label: 'Custo mensal',
                    borderColor: 'rgba(220,0,0,0.9)',
                    backgroundColor: 'rgba(220,0,0,0.9)',
                    data: []
                }
                
                var lineAcumulado = {
                    label: 'Acumulado',
                    borderColor: 'rgba(220,0,0,0.9)',
                    backgroundColor: 'rgba(220,0,0,0.9)',
                    data: [],
                }

                var plota1 = {
                    type: 'bar',
                    objName: 'bar-histograma',
                    titulo: 'Custo por mês',
                    showLegend: false,
                    showYAxes: true,
                    showXAxes: true,
                    // stackedBar: true,
                    labels: [],
                    dataSet:[lineDebito]
                };

                var plota2 = {
                    type: 'bar',
                    objName: 'bar-histogramaacum',
                    titulo: 'Custo acumulado',
                    showLegend: false,
                    showYAxes: true,
                    showXAxes: true,
                    // stackedBar: true,
                    labels: [],
                    dataSet:[lineAcumulado]
                };

                data.Instance.forEach(l => {
                    plota1.labels.push(l.Periodo);
                    plota2.labels.push(l.Periodo);
                    lineDebito.data.push(l.Valor);
                    lineAcumulado.data.push(l.ValorAcum);
                });

                while (lineDebito.data.length < 10) {
                    plota1.labels.push('');
                    lineDebito.data.push(0)
                }
                while (lineAcumulado.data.length < 10) {
                    plota2.labels.push('');
                    lineAcumulado.data.push(0)
                }

                $scope.plotaChart(plota1);
                $scope.plotaChart(plota2);
            });
    }

    $scope.getCustoCategoria = () => {
        var params = {
            IdConstrucao: $scope.construcao.Id
        }
        Relatorio.getCustoCategoria(params,
            (data) => {
                var lineCategoria = {
                    label: 'Categoria',
                    borderColor: 'rgba(220,0,0,0.9)',
                    backgroundColor: 'rgba(220,0,0,0.9)',
                    data: []
                }
                
                var plota = {
                    type: 'horizontalBar',
                    objName: 'bar-custocategoria',
                    titulo: 'Custo por categoria',
                    showLegend: false,
                    showYAxes: true,
                    showXAxes: true,
                    // stackedBar: true,
                    labels: [],
                    dataSet:[lineCategoria]
                };

                data.Instance.forEach(l => {
                    plota.labels.push(l.Categoria.substring(0,15) + (l.Categoria.length >15 ? '...' : '' ));
                    lineCategoria.data.push(l.Valor);
                });

                while (lineCategoria.data.length < 10) {
                    plota.labels.push('');
                    lineCategoria.data.push(0)
                }
                
                $scope.plotaChart(plota);
            });
    }

    $scope.getCustoEtapa = () => {
        var params = {
            IdConstrucao: $scope.construcao.Id
        }
        Relatorio.getCustoEtapa(params,
            (data) => {
                var lineOrcado = {
                    label: 'Orçado',
                    borderColor: 'rgba(38, 49, 67, 0.9)',
                    backgroundColor: 'rgba(38, 49, 67, 0.9)',
                    data: [],
                }

                var lineEtapa = {
                    label: 'Realizado',
                    borderColor: 'rgba(220,0,0,0.9)',
                    backgroundColor: 'rgba(220,0,0,0.9)',
                    data: []
                }
                
                var plota = {
                    type: 'bar',
                    objName: 'bar-custoetapa',
                    titulo: 'Orçado x Realizado',
                    showLegend: true,
                    showYAxes: true,
                    showXAxes: true,
                    // stackedBar: true,
                    labels: [],
                    dataSet:[lineOrcado,lineEtapa]
                };

                var listaCusto = []
                
                data.Instance.filter(c => !$scope.listaEtapa.some(l => l.Etapa == c.Etapa) ).forEach(c => {
                    listaCusto.push(c);
                })

                $scope.listaEtapa.forEach(e => {
                    var etapaCusto = data.Instance.filter(c => c.Etapa == e.Etapa)[0]
                    e.ValorEtapa = etapaCusto ? etapaCusto.ValorEtapa : 0;
                    listaCusto.push(e);
                })

                listaCusto.forEach(l => {
                    plota.labels.push(l.Etapa.substring(0,10) + (l.Etapa.length > 10 ? '...' : '' ));
                    lineEtapa.data.push(l.ValorEtapa);
                    lineOrcado.data.push(l.ValorBDIEncargos);
                });

                while (lineEtapa.data.length < 10) {
                    plota.labels.push('');
                    lineEtapa.data.push(0)
                    lineOrcado.data.push(0);
                }
                
                $scope.plotaChart(plota);
            });
    }

    $scope.getResumoCompras = () => {
        var lineCompra = {
            label: 'Compras',
            borderColor: 'rgba(38, 49, 67, 0.9)',
            backgroundColor: 'rgba(38, 49, 67, 0.9)',
            data: [],
            type: 'bar',
        }

        var plota = {
            type: 'bar',
            objName: 'bar-compras',
            titulo: 'Situação de compras',
            showLegend: false,
            showYAxes: true,
            showXAxes: true,
            labels: [],
            dataSet: [lineCompra]
        };

        Relatorio.getResumoCompras({IdConstrucao: $scope.construcao.Id},
            (data) => {
                $scope.retornoCompras = true
                $scope.showDashboar.Compras = data.Instance.length > 0
                data.Instance.forEach(l => {
                    plota.labels.push(l.Nome)
                    lineCompra.data.push(l.Qtd);
                })

                while (lineCompra.data.length < 6) {
                    plota.labels.push('');
                    lineCompra.data.push(0)
                }

                $scope.plotaChart(plota);
            });

    }

    $scope.getResumoRDO = () => {
        // $scope.histogramaCusto = {};
        var params = {
            IdConstrucao: $scope.construcao.Id,
            Periodo: $scope.opcaoFluxoCaixa ? $scope.opcaoFluxoCaixa : 8
        }
        Relatorio.getResumoRDO(params,
            (data) => {
                $scope.retornoRDO = true;
                $scope.showDashboar.RDO = data.Instance.length > 0
                var lineServico = {
                    label: 'Serviços',
                    borderColor: 'rgba(51, 122, 183, 0.9)',
                    backgroundColor: 'rgba(51, 122, 183, 0.9)',
                    data: []
                }
                
                var lineEquipamento = {
                    label: 'Equipamentos',
                    borderColor: 'rgba(138, 109, 59, 0.9)',
                    backgroundColor: 'rgba(138, 109, 59, 0.9)',
                    data: [],
                }

                var lineOcorrencia = {
                    label: 'Ocorrências',
                    borderColor: 'rgba(38, 49, 67, 0.9)',
                    backgroundColor: 'rgba(38, 49, 67, 0.9)',
                    data: [],
                }

                var plota1 = {
                    type: 'bar',
                    objName: 'bar-rdoservico',
                    titulo: 'Serviços realizados',
                    showLegend: false,
                    showYAxes: true,
                    showXAxes: true,
                    // stackedBar: true,
                    labels: [],
                    dataSet:[lineServico]
                };

                var plota2 = {
                    type: 'bar',
                    objName: 'bar-rdoequipamento',
                    titulo: 'Equipamentos utilizados',
                    showLegend: false,
                    showYAxes: true,
                    showXAxes: true,
                    // stackedBar: true,
                    labels: [],
                    dataSet:[lineEquipamento]
                };

                var plota3 = {
                    type: 'bar',
                    objName: 'bar-rdoocorrencia',
                    titulo: 'Ocorrências registradas',
                    showLegend: false,
                    showYAxes: true,
                    showXAxes: true,
                    // stackedBar: true,
                    labels: [],
                    dataSet:[lineOcorrencia]
                };

                data.Instance.forEach(l => {
                    plota1.labels.push(l.Periodo);
                    plota2.labels.push(l.Periodo);
                    plota3.labels.push(l.Periodo);
                    lineServico.data.push(l.QtdSer);
                    lineEquipamento.data.push(l.QtdEqu);
                    lineOcorrencia.data.push(l.QtdOco);
                });

                while (lineServico.data.length < 10) {
                    plota1.labels.push('');
                    lineServico.data.push(0)
                }
                while (lineEquipamento.data.length < 10) {
                    plota2.labels.push('');
                    lineEquipamento.data.push(0)
                }

                while (lineOcorrencia.data.length < 10) {
                    plota3.labels.push('');
                    lineOcorrencia.data.push(0)
                }

                $scope.plotaChart(plota1);
                $scope.plotaChart(plota2);
                $scope.plotaChart(plota3);
            });
    }

    $scope.getResumoTempo = () => {
        var params = {
            IdConstrucao: $scope.construcao.Id
        }
        Relatorio.getResumoTempo(params,
            (data) => {
                var tempo = data.Instance[0];
                var plota1 = {
                    type: 'bar',
                    objName: 'bar-tempomanha',
                    titulo: 'Tempo de manhã',
                    showLegend: false,
                    showYAxes: true,
                    showXAxes: true,
                    labels: [],
                    dataSet: []
                };
        
                plota1.dataSet = [{
                    borderColor: [
                        'rgba(38, 49, 67, 0.9)',
                        'rgba(60, 118, 61, 0.9)',
                        'rgba(138, 109, 59, 0.9)',
                        'rgba(51, 122, 183, 0.9)',
                    ],
                    backgroundColor: [
                        'rgba(38, 49, 67, 0.9)',
                        'rgba(60, 118, 61, 0.9)',
                        'rgba(138, 109, 59, 0.9)',
                        'rgba(51, 122, 183, 0.9)',
                    ],
                    // borderWidth: 0.5,
                    data: [
                        tempo.ManhaSol,
                        tempo.ManhaNublado,
                        tempo.ManhaChuva,
                        tempo.ManhaImprat
                    ]
                }];
    
                plota1.labels = [
                    'SOL',
                    'NUBLADO',
                    'CHUVA',
                    'IMPRATICÁVEL'
                ];
    
                $scope.plotaChart(plota1);

                var plota2 = {
                    type: 'bar',
                    objName: 'bar-tempotarde',
                    titulo: 'Tempo de tarde',
                    showLegend: false,
                    showYAxes: true,
                    showXAxes: true,
                    labels: [],
                    dataSet: []
                };
        
                plota2.dataSet = [{
                    borderColor: [
                        'rgba(38, 49, 67, 0.9)',
                        'rgba(60, 118, 61, 0.9)',
                        'rgba(138, 109, 59, 0.9)',
                        'rgba(51, 122, 183, 0.9)',
                    ],
                    backgroundColor: [
                        'rgba(38, 49, 67, 0.9)',
                        'rgba(60, 118, 61, 0.9)',
                        'rgba(138, 109, 59, 0.9)',
                        'rgba(51, 122, 183, 0.9)',
                    ],
                    // borderWidth: 0.5,
                    data: [
                        tempo.TardeSol,
                        tempo.TardeNublado,
                        tempo.TardeChuva,
                        tempo.TardeImprat
                    ]
                }];
    
                plota2.labels = [
                    'SOL',
                    'NUBLADO',
                    'CHUVA',
                    'IMPRATICÁVEL'
                ];

                $scope.plotaChart(plota2);
            });
    }

    $scope.getMedicaoEtapa = () => {
    
        Material.getMedicoesFisicas($scope.construcao.Id, $scope.paginacao, (data) => {
            $scope.retornoMedicao = true;
            var listaMedicao = [];

            $scope.showDashboar.Medicao = data.Instance.length > 0

            var calculado = []
            $scope.listaEtapa.forEach(e => {
                e.Medido = 0;
                data.Instance.filter(m => m.IdEtapa == e.IdEtapa).forEach(m => {
                    e.Medido += m.PercentualEtapa;
                    calculado.push(m.IdEtapa)
                })

                var valorMedido = 0;
                data.Instance.filter(m => m.Ordem.split('.')[0] == e.Ordem && calculado.indexOf(m.IdEtapa) < 0).forEach(m => {
                    console.log(m.PercentualEtapa)
                    valorMedido += m.ValorEtapa
                })

                if (valorMedido > 0)
                    e.Medido += (valorMedido/e.ValorBDIEncargos)*100;

                listaMedicao.push(e);
            })

            var lineOrcado = {
                label: 'Orçado',
                borderColor: 'rgba(38, 49, 67, 0.9)',
                backgroundColor: 'rgba(38, 49, 67, 0.9)',
                data: [],
            }
            var lineMedicao = {
                label: 'Medido',
                borderColor: 'rgba(250,162,0,0.9)',
                backgroundColor: 'rgba(250,162,0,0.9)',
                data: []
            }
            
            var plota = {
                type: 'horizontalBar',
                objName: 'bar-medicaoetapa',
                titulo: 'Medição por etapa',
                showLegend: true,
                showYAxes: true,
                showXAxes: true,
                // stackedBar: true,
                labels: [],
                dataSet:[lineOrcado,lineMedicao]
            };

            listaMedicao.forEach(l => {
                plota.labels.push(l.Etapa);//.substring(0,10) + (l.Etapa.length >10 ? '...' : '' ));
                lineOrcado.data.push(l.ValorBDIEncargos);
                lineMedicao.data.push(l.ValorBDIEncargos*(l.Medido.toFixed(0)/100));
                // lineOrcado.data.push(100);
                // lineMedicao.data.push(l.Medido.toFixed(0));
            });

            while (lineMedicao.data.length < 10) {
                plota.labels.push('');
                lineMedicao.data.push(0)
                lineOrcado.data.push(0);
            }

            $scope.plotaChart(plota);
        });
    }

    $scope.getCurvaAbcFornecedor = () => {
        var lineFornecedor = {
            label: 'Fornecedor',
            borderColor: 'rgba(220,0,0,0.9)',
            backgroundColor: 'rgba(220,0,0,0.9)',
            data: [],
        }

        var plota = {
            type: 'horizontalBar',
            objName: 'bar-fornecedor',
            titulo: 'Custo por fornecedor',
            showLegend: false,
            showYAxes: true,
            showXAxes: true,
            labels: [],
            dataSet: [lineFornecedor]
        };

        Relatorio.getCurvaAbcFornecedor({IdConstrucao: $scope.construcao.Id},
            (data) => {
                data.Instance.forEach(l => {
                    plota.labels.push(l.Nome.substring(0,15) + (l.Nome.length >15 ? '...' : '' ));
                    lineFornecedor.data.push(l.Valor);
                })

                while (lineFornecedor.data.length < 10) {
                    plota.labels.push('');
                    lineFornecedor.data.push(0)
                }

                $scope.plotaChart(plota);
            });

    }

    $scope.excluirConstrucao = (construcao) => {
        $scope.msgBoxPergunta(construcao.Titulo, 'Confirma exclusão da ' + construcao.TipoDescricao + '?'
            , () => {
                Construcao.delConstrucao(construcao.Id,
                    (data) => {
                        $scope.getConstrucoes();
                    });
            }
            , () => {
            });
    }

    $scope.CopiarColarConstrucao = (construcao) => {
        var params = { 
            IdConstrucao: construcao.Id,
            IdClienteAdmin: construcao.IdClienteDono
        }
        Construcao.clonarConstrucao(params,
            (data) => {
                setTimeout(() => { $scope.getConstrucoes(); }, 500);
            });
    }

    $scope.finalizarConstrucao = (construcao) => {
        $scope.msgBoxPergunta('Finalizar ' + construcao.Titulo, 'Sua ' + construcao.TipoDescricao + ' ficará disponível somente para consulta, confirma a finalização?'
            , () => {

                swal({
                    title: 'Data de Finalização',
                    html: '<input type="date" class="input-lg" id="DataFinalizada" datasafari />',
                    showCancelButton: true,
                    confirmButtonColor: '#263143',
                    cancelButtonColor: '#F6A000',
                    confirmButtonText: 'Salvar',
                    cancelButtonText: "Cancelar",
                    onOpen: () => {
                        $('#DataFinalizada').val( $filter("date")(new Date(), 'yyyy-MM-dd') );
                    }
                    }).then((result) => {
                        if (result.value) {
                            Construcao.finalizarConstrucao(construcao.Id, $('#DataFinalizada').val()+' 03:05:00',
                                (data) => {
                                    $scope.msgBoxSucesso(construcao.TipoDescricao + ' Finalizada', 'Finalização executada com sucesso! Parabéns por mais uma empreitada concluída. : )',
                                        () => {
                                            $scope.getConstrucoes();
                                        });
                                });

                        }
                    }
                );

            }
            , () => {
            });

    }

    $scope.reabrirConstrucao = (construcao) => {
        Construcao.reabrirConstrucao(construcao.Id,
            (data) => {
                $scope.getConstrucoes();
            });
    }

    $scope.compartilharObra = (construcao) => {
        CacheApp.setConstrucao(construcao);
        $scope.AtualizaConstrucao();
        $location.path('/acessos');
    };

    $scope.CopyUrl = (construcao) => {
        Construcao.getUrlCompartilhamento({IdConstrucao: construcao.Id}, 
            (data) => {
                $scope.CopyText(data.Instance);
            }
        );
    }

    $scope.Descompartilhar = (construcao) => {
        var cliente = { IdCliente: $scope.sessao.IdCliente, IdConstrucao: construcao.Id };

        Construcao.delAcessosConstrucao(cliente,
            (data) => {
                var idx = $scope.construcoes.indexOf(construcao);
                $scope.construcoes.splice(idx, 1);
            });
    }

    $scope.getListaConstrucao = (callBack) => {
        var params = {
            // permissao: 'GET_ORCAMENTO',
            refresh: $scope.refreshObra ? true: false
        }
        $scope.getListaObraCache(params, 
            (obra)=> {
                $scope.construcoes = obra
                callBack()
            }
        )
    }

    $scope.filtraObra = (obra) => {
        if (obra && obra.id) {
            $scope.setObraSelecionada($scope.construcoes.filter(c => c.Id == obra.id)[0])
        }
        else {
            $scope.construcao = undefined;
            CacheApp.delConstrucao();
            $scope.listaRelatorio = [];
        }
    }

    $scope.setObraSelecionada = (obra) => {
        $scope.orcamento = undefined;
        $scope.construcao = obra;
        CacheApp.setConstrucao($scope.construcao);
        
        $scope.comEncargos = ($scope.construcao.EncargoSocial > 0)
        $scope.comBDI = $scope.construcao.BDI > 0 || $scope.construcao.BDIMaoObra > 0 || $scope.construcao.BDIMaterial > 0 || $scope.construcao.BDIEquipamento > 0 || $scope.construcao.BDIServico > 0 || $scope.construcao.BDITaxa > 0
        $scope.HtmlManterObra = undefined

        $scope.listaRelatorio = [];
        $scope.listaRelatorio = $scope.reportList.filter(r => obra.Acessos.indexOf(r.Permissao) >= 0);

        $scope.loadPage()
    }

    $scope.editarObra = () => {
        if (!$scope.HtmlManterObra)
            $scope.HtmlManterObra = `
                <manterobra mo-obra="construcao">
                </manterobra>
            `;
        $scope.openObra = !$scope.openObra;
    }

    $scope.adicionarObra = () => {
        if ($scope.sessao.TipoPlano == 3 && $scope.construcoes && $scope.construcoes.length > 2) {
            CacheApp.msgBoxAcessoPremium();
            return;
        }

        $scope.construcao = { Tipo: 0, Dono: true, Novo: true }
        $scope.editarObra()
    }

    $scope.salvarObra = () => {
        $rootScope.$broadcast('salvarObra', {});
    }

    $scope.$on('refreshComboObra', (events,args) => {
        $scope.refreshObra = true
        $scope.loadObra();
    })

    $scope.loadObra = () => {
        $scope.ObraSelecionada = CacheApp.getConstrucao()
        CacheApp.delConstrucao()
        $scope.AtualizaConstrucao()
        $scope.getListaConstrucao(()=>{
            if ($scope.ObraSelecionada && $scope.construcoes.some(c => c.Id == $scope.ObraSelecionada.Id)) {
                $scope.ObraSelecionada = $scope.construcoes.filter(c => c.Id == $scope.ObraSelecionada.Id)[0]
            }
            else {
                if ($scope.construcoes.length > 0)
                    $scope.ObraSelecionada = $scope.construcoes[0]
                else
                    $scope.ObraSelecionada = undefined
            }

            if ($scope.ObraSelecionada) {
                $scope.listaSelecao = {
                    id: $scope.ObraSelecionada.Id, 
                    model: $scope.ObraSelecionada.Titulo, 
                    label: $scope.ObraSelecionada.Titulo,
                    checked: true
                }
                $scope.setObraSelecionada($scope.ObraSelecionada)
            }

        })
    }

    $scope.loadPage = () => {
        $scope.sessao = CacheApp.getSessao();

        $scope.opcaoFluxoCaixa = 8;
        $scope.showDashboar = {
            Orcamento: true,
            Financeiro: true,
            Compras: true,
            RDO: true,
            Cronograma: true,
            Medicao: true
        }
        $scope.getConstrucao();
    }

    $scope.reportList = [
        { Id: 0, Descricao: 'Curva ABC de Serviços', Permissao: 'GET_CURVAABC', Url: 'curvaabc' },
        { Id: 1, Descricao: 'Curva ABC de Insumos', Permissao: 'GET_RELATCURVAABCMEDICAO', Url: 'curvaabcmedicaoitem' },
        { Id: 2, Descricao: 'Orçamento Analítico de Custo', Permissao: 'GET_ORCAMENTOANALITICO', Url: 'orcamentoanalitico' },
        { Id: 3, Descricao: 'Orçamento Sintético de Custo', Permissao: 'GET_ORCAMENTOANALITICO', Url: 'orcamentosintetico' },
        { Id: 4, Descricao: 'Orçamento Analítico com BDI e Encargos Sociais', Permissao: 'GET_ORCAMENTOBDI', Url: 'orcamentobdiexplicito' },
        { Id: 5, Descricao: 'Orçamento Sintético com BDI e Encargos Sociais', Permissao: 'GET_ORCAMENTOBDI', Url: 'orcamentobdiexplicitosintetico' },
        { Id: 6, Descricao: 'Orçamento Analítico para Proposta', Permissao: 'GET_ORCAMENTOPROPOSTA', Url: 'orcamentobdicliente' },
        { Id: 7, Descricao: 'Orçamento Sintético para Proposta', Permissao: 'GET_ORCAMENTOPROPOSTA', Url: 'orcamentobdiclientesintetico' },
        { Id: 25, Descricao: 'Orçamento Analítico Para Proposta (MDO x MAT)', Permissao: 'GET_ORCAMENTOANALITICO', Url: 'orcamentoanaliticomatxmdo' },
        { Id: 26, Descricao: 'Orçamento Analítico Para Licitação', Permissao: 'GET_ORCAMENTOANALITICO', Url: 'orcamentoanaliticolicitacao' },
        { Id: 23, Descricao: 'Composição de Preços Unitários', Permissao: 'GET_RELATCOMPOSICAO', Url: 'relatoriocomposicao', Divider: true },
        { Id: 8, Descricao: 'Cronograma Físico Financeiro', Permissao: 'GET_RELATCRONFISICOFINANCEIRO', Url: 'cronogramaff' },
        { Id: 24, Descricao: 'Cronograma Resumido', Permissao: 'GET_RELATCRONFISICOFINANCEIRO', Url: 'cronogramaresumido' },
        { Id: 21, Descricao: 'Gráfico de Gantt', Permissao: 'GET_RELATCRONFISICOFINANCEIRO', Url: 'ganttchart' },
        { Id: 22, Descricao: 'Acompanhamento do Cronograma', Permissao: 'GET_RELATCRONFISICOFINANCEIRO', Url: 'ganttchartmeasure', Divider: true },
        { Id: 10, Descricao: 'Boletim de Medição', Permissao: 'GET_BOLETIMMEDICAOI', Url: 'boletimmedicao' },
        { Id: 11, Descricao: 'Boletim de Medição Cliente', Permissao: 'GET_BOLETIMMEDICAOCLIENTE', Url: 'boletimmedicaocliente' },
        { Id: 12, Descricao: 'Medição por Período', Permissao: 'GET_BOLETIMMEDICAOI', Url: 'medicaoperiodo' },
        { Id: 29, Descricao: 'Boletim de Medição Por Fornecedor/Colaborador', Permissao: 'GET_BOLETIMMEDICAOI', Url: 'boletimmedicaofornecedor' },
        { Id: 30, Descricao: 'Boletim de Medição Lista Fornecedor/Colaborador', Permissao: 'GET_BOLETIMMEDICAOI', Url: 'boletimmedicaofornecedorall', Divider: true },
        { Id: 13, Descricao: 'Relatório Analítico de Lançamentos', Permissao: 'GET_RELATCUSTO', Url: 'relatoriocustoobra' },
        { Id: 14, Descricao: 'Relatório Sintético de Lançamentos', Permissao: 'GET_RELATCUSTO', Url: 'custoobrasintetico' },
        { Id: 15, Descricao: 'Relatório Orçado X Realizado', Permissao: 'GET_ORCAMENTOCUSTO', Url: 'relatorioorcadocustoobra' },
        { Id: 16, Descricao: 'Relatório BDI', Permissao: 'GET_RELATORIOBDI', Url: 'relatoriobdi' },
        { Id: 17, Descricao: 'Relatório de Lançamentos Por Categoria', Permissao: 'GET_RELATORIOCUSTOCATEGORIA', Url: 'relatoriocustocategoria' },
        { Id: 18, Descricao: 'Relatório Contas a Pagar', Permissao: 'GET_RELATORIODEBITOPERIODO', Url: 'relatoriodebitoperiodo' },
        { Id: 19, Descricao: 'Relatório Contas a Receber', Permissao: 'GET_RELATORIOCREDITOPERIODO', Url: 'relatoriocreditoperiodo', Divider: true },
        { Id: 20, Descricao: 'Relatório de Ocorrências', Permissao: 'GET_RELATORIOOCORRENCIAS', Url: 'relatorioocorrencia' },
        { Id: 21, Descricao: 'Relatório Fotográfico', Permissao: 'GET_RELATORIOFOTOGRAFICO', Url: 'relatoriofotografico' },
        { Id: 27, Descricao: 'Lista Compras', Permissao: 'GET_COMPRA_SOLICITACAO,GET_COMPRA_ALMOXARIFADO,GET_COMPRA_COTACAO,GET_COMPRA_ANALISE,GET_COMPRA_APROVADA,GET_COMPRA_ENTREGUE,GET_COMPRA_RETIRADA_ALMOXARIFADO', Url: 'relatoriocompras' },
        { Id: 28, Descricao: 'Lista Almoxarifado', Permissao: 'GET_ALMOXARIFADO', Url: 'relatorioalmoxarifado' },
        
    ]
    $scope.loadObra()

  }]);
